package com.helioscloud.middleware.sample;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.helioscloud.middleware.dto.IntegrationCommonResponseDTO;
import com.helioscloud.middleware.dto.IntegrationSimpleResponseDTO;
import com.helioscloud.middleware.service.MidBusinessFailService;
import com.helioscloud.middleware.service.artemis.ArtemisExpenseReportService;
import com.helioscloud.middleware.service.artemis.template.ArtemisExpenseReportDataOutputTemplate;
import org.apache.xpath.operations.Bool;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Project Name:middleware-core
 * Package Name:com.helioscloud.middleware.sample
 * Date:2017/7/12
 * Create By:zongyun.zhou@hand-china.com
 */
@Service
public class SampleArtemisExpenseReportDataOutputTemplate extends ArtemisExpenseReportDataOutputTemplate {
    public SampleArtemisExpenseReportDataOutputTemplate(ApplicationEventPublisher messageEventPublisher, MidBusinessFailService midBusinessFailService, ArtemisExpenseReportService artemisExpenseReportService) {
        super(messageEventPublisher, midBusinessFailService, artemisExpenseReportService);
    }

    @Override
    public IntegrationSimpleResponseDTO doIntegrationApi(List<Map<String, Object>> param) {
        IntegrationSimpleResponseDTO responseDTO = new IntegrationSimpleResponseDTO();
        for (Map<String, Object> p : param) {
            IntegrationCommonResponseDTO integrationCommonResponseDTO = new IntegrationCommonResponseDTO();
            integrationCommonResponseDTO.setSuccess(Boolean.TRUE);
            integrationCommonResponseDTO.setRequestJson(JSON.toJSONString(p));
            responseDTO.put(integrationCommonResponseDTO);
        }
        return responseDTO;
    }

    @Override
    public List<Map<String, Object>> doIntegrationParameterAdaption(JSONObject raw) {
        List<Map<String, Object>> result = new ArrayList<Map<String, Object>>();
        JSONArray param = raw.getJSONArray("result");
        for (int i = 0; i < param.size(); i++) {
            String businessCode = param.getJSONObject(i).getString("businessCode");
            String applicantName = param.getJSONObject(i).getString("applicantName");
            Map<String, Object> expenseReport = new HashMap<String, Object>();
            expenseReport.put("businessCode", businessCode);
            expenseReport.put("applicantName", applicantName);
            result.add(expenseReport);
        }
        return result;
    }
}
